{ "Safe Keeping" Copyright 1989 by ST-LOG }

Program Safe_Keeping;

{$I GEMSUBS.PAS}
{$I AUXSUBS.PAS}

var
  Infile_name, Outfile_name, Password: string[255];
  Infile, Outfile: packed file of byte;
  key: array[1..80] of byte;
  key_length, rez: integer;
  { menu headings }
  About_Safe, Fyle, Password_menu, Quit: integer;
  { menu items }
  About_Menu, File_Open, Pass_echo, Pass_no_echo, Quit_Quit,
       opt_dead, opt_delete, opt_no_delete: integer;
  Menu: menu_ptr;
  echo, deleet: boolean;
  path: path_name;

Function GetRez: integer;
  XBIOS(4);
   
Procedure Set_Up_Menus;
 Begin
  Menu:=New_Menu(10,' About Safe Keeping ');
  Fyle:=Add_Mtitle(Menu,' Lock/Unlock ');
  Password_menu:=Add_Mtitle(Menu,' Options ');
  Quit:=Add_Mtitle(Menu,' Quit ');
  Quit_Quit:= Add_Mitem(Menu, Quit, ' Quit ');
  Pass_echo:= Add_Mitem(Menu, Password_menu,    '  Echo Password        ');
  Pass_no_echo:= Add_Mitem(Menu, Password_menu, '  Do not Echo Password ');
  Opt_dead:= Add_Mitem(Menu, Password_menu,     '-----------------------');
  opt_delete:= ADd_Mitem(Menu, Password_menu,   '  Delete After Locking ');
  opt_no_delete:= Add_Mitem(Menu, Password_menu,'  Do not delete        ');
  File_Open:= Add_Mitem(Menu, Fyle, ' Lock or Unlock a File ');  
  Menu_Check(Menu, Pass_Echo,True);
  Menu_Check(Menu, opt_no_delete, True);
  Menu_Disable(Menu, opt_dead);
  echo:= True;
  deleet:= False;
  Draw_Menu(Menu);
 End; { of procedure Set_Up_Menus }

Procedure Create_Key;
var
  temp: record
         case boolean of
           True:(c: char);
           False:(b: byte);
        end;
  i: integer;
begin
  for i:= 1 to (length(password) -1) do begin
    temp.c:= password[i];
    key[i]:= temp.b;
  end;
  key_length:= length(password);
end;

Function Keyin:Integer;
 var Message:Message_Buffer;
     EKey,d:Integer;
begin
 d:=Get_Event(E_Keyboard,0,0,0,0,False,0,0,0,0,False,0,0,0,0,
                    Message,EKey,d,d,d,d,d);
 Keyin:=EKey;
end; { of func Keyin }

Procedure Get_String(X,Y,MaxLength:Integer;Var Str:String);
 { returns a string entered at screen position X,Y of Maximum length MaxLength}
 var Ch:Char; I,Length:Integer; Temp:String;
 begin
  Hide_Mouse;
  Draw_String(X,Y,'_');Length:=0;Temp:='';
  Repeat
   I:=Keyin & $FF;
   If (I=8)AND(Length>0) then begin
     Length:=Length-1;
     Draw_String(X+Length*8,Y,'  ');
     Draw_String(X+Length*8,Y,'_');
     Delete(Temp,Length+1,1);
     end
     else
   If (I<>$0D) AND (I<>8) AND (I<>$1B) then begin
     If Length<MaxLength then Temp:=Concat(Temp,Chr(I))
      else begin
        Delete(Temp,MaxLength,1);
        Temp:=Concat(Temp,Chr(I));
        end;
     If Length<MaxLength then Length:=Length+1;
     Paint_Color(White);Paint_Rect(X+Length*8,Y-8,16,8);
     If echo then
       Draw_String(X+Length*8-8,Y,Chr(I))
     else
       Draw_String(X+Length*8-8,Y,'*');
     Draw_String(X+Length*8,Y,'_');
    end;
  Until (I=$0D);
  Draw_String(X+Length*8,Y,' ');
  Str:=Temp;
  Show_Mouse;
 end; { of proc Get_STring }

Function F_Delete(Var Name: Cstring): Integer;
  GemDos($41);

Function Get_Inputs: boolean;
label
 1;
var
  File_Selected, temp: boolean;
begin
  Get_Inputs:= False;
  hide_mouse;
  Draw_String(204,20*rez,'Select File to Lock or Unlock');
  show_mouse;
  File_Selected:= Get_In_File(path, infile_name);
  hide_mouse;
  paint_color(green);
  paint_rect(0,9*rez+(rez mod 2)*2,640,200*rez);
  show_mouse;
  If NOT File_Selected then goto 1;
  hide_mouse;
  Draw_String(224,20*rez,'Select New File Name');
  show_mouse;
  outfile_name:= infile_name;
  Repeat
    File_Selected:= Get_In_File(path, outfile_name);
  Until ((infile_name <> outfile_name) OR (Not File_Selected));
  hide_mouse;
  paint_rect(0,9*rez+(rez mod 2)*2,640,200*rez);
  show_mouse;
  If NOT File_Selected then goto 1;
  paint_color(white);
  paint_rect(0,50*rez,640,25*rez);
  Draw_String(1,60*rez,'Enter Password(s)');
  Get_String(1,70*rez,80,Password);
  paint_color(green);
  hide_mouse;
  paint_rect(0,9*rez+(rez mod 2)*2,640,200*rez);
  show_mouse;
  Create_Key;
  Get_Inputs:= True;
  
  1:          { come here if cancel selected }
end;

Function XOR(A, B: byte):byte;
var
  AA, BB, CC: record
              case boolean of
               True:(b: byte);
               False:(i: integer);
              end;
begin
  AA.b:= A;
  BB.b:= B;
  CC.i:= ((~AA.i) & BB.i) | ((~BB.i) & AA.i);
  XOR:= CC.b;
end;


Procedure Read_Write;
var
  temp: byte;
  buffer: array[1..100000] of byte;
  read_count, the_end: long_integer;
  count: integer;
  been_looping: boolean;
  del_path: Cstring;
begin
  been_looping:= False;
  hide_mouse;
  begin_mouse;
  Draw_String(280,60*rez,'Reading...');
  Reset(infile, infile_name);
  Rewrite(outfile, outfile_name);
  count:= 1;
  While NOT EOF(infile) do begin
    if been_looping then Draw_String(280,60*rez,'Reading...');
    been_looping:= True;
    read_count:= 1;
    while((NOT EOF(infile)) AND (read_count <= 100000)) do begin
      read(infile, buffer[read_count]);
      read_count:= read_count+1;
    end;
    if read_count<100000 then the_end:= read_count -1 
      else the_end:= 100000;
    paint_color(green);
    paint_rect(0,9*rez+(rez mod 2)*2,640,200*rez);
    Draw_String(280,60*rez,'Writing...');
    for read_count:= 1 to the_end do begin
      temp:= XOR(buffer[read_count], key[count]);
      write(outfile, temp);
      count:= count +1;
      if (count > key_length) then count:= 1;
    end;
  end;
  
  close(infile);
  close(outfile);
  paint_rect(0,9*rez+(rez mod 2)*2,640,200*rez);
  
  if deleet then begin
    Draw_String(278,60*rez,'Deleting...');
    PtoCstr(infile_name, del_path);
    count:= f_delete(del_path);
    paint_rect(0,9*rez+(rez mod 2)*2,640,200*rez);
  end;
  
  show_mouse;
  end_mouse;
  
end;

Procedure Copyright;
var Alert_String: string[255];
    d: integer;
begin
  Alert_String:=Concat('[0][         SAFE KEEPING         | |',
                           '    (c)1988 by Mark Nelson|',
   '  portions (c)1985 OSS and CCD |      Used by permission.]',
   '[   OK   ]');

  d:= Do_Alert(Alert_String,1);

end;

Procedure Set_up;
begin
  rez:= GetRez;
  if rez = 2 then paint_style(5);
  Set_up_Menus;
  Init_Mouse;
  path:= 'A:*.*';
  infile_name:= '';
  Copyright;
end;

Procedure Do_it;
begin
  If Get_Inputs then Read_Write;
end;

Procedure Get_Out;
begin
  Exit_Gem;
  Halt;
end;

Procedure Main_Event; 
 Var d,k:integer;    { d is a dummy variable }
     Msg_area: Message_Buffer;
 begin
  K:=Get_Event(E_Message,0,0,0,0,
               False,0,0,0,0,false,0,0,0,0,
               msg_area,d,d,d,d,d,d);

 If Msg_area[0]=Mn_Selected then begin
  Menu_Normal(Menu,3);Menu_Normal(Menu,Fyle);Menu_Normal(Menu,Quit);
  Menu_Normal(Menu,Password_menu);

  if msg_area[3] = 3 then Copyright;     { About Safe Keeping... }
     
  If msg_area[4] = Quit_Quit then Get_Out;

  If msg_area[4] = file_open then do_it;

  If msg_area[4] = Pass_echo then begin
    Menu_Check(Menu, Pass_echo, True);
    Menu_Check(Menu, Pass_no_echo, False);
    echo:= True;
  end;

  if msg_area[4] = Pass_no_echo then begin
    Menu_Check(Menu, Pass_no_echo, True);
    Menu_Check(Menu, Pass_echo, False);
    echo:= False;
  end;
  
  If msg_area[4] = Opt_delete then begin
    Menu_Check(Menu, Opt_delete, True);
    Menu_Check(Menu, Opt_no_delete, False);
    deleet:= True;
  end;
  
  If msg_area[4] = Opt_no_delete then begin
    Menu_Check(Menu, Opt_no_delete, True);
    Menu_Check(Menu, Opt_delete, False);
    deleet:= False;
  end;
  
  end;
 end; { of procedure Main_Event }


begin
if init_gem >= 0 then
begin
  Set_Up;
  Repeat
    Main_Event;
  Until FALSE;
  Exit_Gem;
end;
end.

